From 8a2e1006b3b272126332aa064f3ad95387129544 Mon Sep 17 00:00:00 2001
From: Biswakalyan Bhuyan <biswa@surgot.in>
Date: Thu, 13 Feb 2025 14:13:49 +0530
Subject: new dot files

---
 .config/zsh/oh-my-zsh/plugins/transfer/README.md   | 41 +++++++++
 .../oh-my-zsh/plugins/transfer/transfer.plugin.zsh | 97 ++++++++++++++++++++++
 2 files changed, 138 insertions(+)
 create mode 100644 .config/zsh/oh-my-zsh/plugins/transfer/README.md
 create mode 100644 .config/zsh/oh-my-zsh/plugins/transfer/transfer.plugin.zsh

(limited to '.config/zsh/oh-my-zsh/plugins/transfer')

diff --git a/.config/zsh/oh-my-zsh/plugins/transfer/README.md b/.config/zsh/oh-my-zsh/plugins/transfer/README.md
new file mode 100644
index 0000000..825c9a2
--- /dev/null
+++ b/.config/zsh/oh-my-zsh/plugins/transfer/README.md
@@ -0,0 +1,41 @@
+# `transfer` plugin
+
+[`transfer.sh`](https://transfer.sh) is an easy to use file sharing service from the command line
+
+To use it, add `transfer` to the plugins array in your zshrc file:
+
+```zsh
+plugins=(... transfer)
+```
+
+## Usage
+
+- Transfer a file: `transfer file.txt`.
+
+- Transfer a whole directory (it will be automatically compressed): `transfer dir`.
+
+### Encryption / Decryption
+
+- Encrypt and upload a file with symmetric cipher and create ASCII armored output:
+
+  ```zsh
+  transfer file -ca
+  ```
+
+- Encrypt and upload directory with symmetric cipher and gpg output:
+
+  ```zsh
+  transfer directory -ca
+  ```
+
+- Decrypt file:
+
+  ```zsh
+  gpg -d file -ca
+  ```
+
+- Decrypt directory:
+
+  ```zsh
+  gpg -d your_archive.tgz.gpg | tar xz
+  ```
diff --git a/.config/zsh/oh-my-zsh/plugins/transfer/transfer.plugin.zsh b/.config/zsh/oh-my-zsh/plugins/transfer/transfer.plugin.zsh
new file mode 100644
index 0000000..b34e115
--- /dev/null
+++ b/.config/zsh/oh-my-zsh/plugins/transfer/transfer.plugin.zsh
@@ -0,0 +1,97 @@
+# Author:
+#   Remco Verhoef <remco@dutchcoders.io>
+#   https://gist.github.com/nl5887/a511f172d3fb3cd0e42d
+#   Modified to use tar command instead of zip
+#
+
+transfer() {
+  # check arguments
+  if [[ $# -eq 0 ]]; then
+  cat <<EOF
+Error: no arguments specified.
+
+Usage: transfer [file/folder] [options]
+
+Examples:
+  transfer /tmp/test.md
+  transfer /tmp/test.md -ca
+  cat /tmp/test.md | transfer test.md
+  cat /tmp/test.md | transfer test.md -ca
+
+Options:
+  -ca  Encrypt file with symmetric cipher and create ASCII armored output
+EOF
+  return 1
+  fi
+
+  if (( ! $+commands[curl] )); then
+    echo "Error: curl is not installed"
+    return 1
+  fi
+
+  local tmpfile tarfile item basename
+
+  # get temporarily filename, output is written to this file show progress can be showed
+  tmpfile=$(mktemp -t transferXXX)
+
+  # upload stdin or file
+  item="$1"
+
+  # crypt file with symmetric cipher and create ASCII armored output
+  local crypt=0
+  if [[ "$2" = -ca ]]; then
+    crypt=1
+    if (( ! $+commands[gpg] )); then
+      echo "Error: gpg is not installed"
+      return 1
+    fi
+  fi
+
+  if ! tty -s; then
+    # transfer from pipe
+    if (( crypt )); then
+      gpg -aco - | curl -X PUT --progress-bar -T - "https://transfer.sh/$item" >> $tmpfile
+    else
+      curl --progress-bar --upload-file - "https://transfer.sh/$item" >> $tmpfile
+    fi
+  else
+    basename=$(basename "$item" | sed -e 's/[^a-zA-Z0-9._-]/-/g')
+
+    if [[ ! -e $item ]]; then
+      echo "File $item doesn't exist."
+      return 1
+    fi
+
+    if [[ -d $item ]]; then
+      # tar directory and transfer
+      tarfile=$(mktemp -t transferXXX.tar.gz)
+      cd $(dirname $item) || {
+        echo "Error: Could not change to directory $(dirname $item)"
+        return 1
+      }
+
+      tar -czf $tarfile $(basename $item)
+      if (( crypt )); then
+        gpg -cao - "$tarfile" | curl --progress-bar -T "-" "https://transfer.sh/$basename.tar.gz.gpg" >> $tmpfile
+      else
+        curl --progress-bar --upload-file "$tarfile" "https://transfer.sh/$basename.tar.gz" >> $tmpfile
+      fi
+      rm -f $tarfile
+    else
+      # transfer file
+      if (( crypt )); then
+        gpg -cao - "$item" | curl --progress-bar -T "-" "https://transfer.sh/$basename.gpg" >> $tmpfile
+      else
+        curl --progress-bar --upload-file "$item" "https://transfer.sh/$basename" >> $tmpfile
+      fi
+    fi
+  fi
+
+  # cat output link
+  cat $tmpfile
+  # add newline
+  echo
+
+  # cleanup
+  rm -f $tmpfile
+}
-- 
cgit v1.2.3-59-g8ed1b